Subject: Re: 2.6.17: networking bug??

From: Matt Mackall <[email-masked]>
Date: Tue, 13 Jun 2006 18:22:55 -0500

On Tue, Jun 13, 2006 at 05:49:21PM -0400, Mark Lord wrote:
> 
> 
> David Miller wrote:
> >..
> >First, you are getting window scaling by default with the older
> >kernel too.  It's just a smaller window scale, using a shift
> >value of say 1 or 2.
> >
> >What these broken middle boxes do is ignore the window scale
> >entirely.
> >
> >So they don't apply a window scale to the advertised windows in each
> >packet.  Therefore, they think a smaller amount of window space is
> >being advertised than really is.  So they will silently drop packets
> >they think is outside of this bogus window they've calculated.
> >
> >Now, when the window scale is smaller, the connection can still limp
> >along, albeit slowly, making forward progress even in the face of such
> >broken devices because half or a quarter of the window is still
> >available.  It will retransmit a lot, and the congestion window won't
> >grow at all.
> >
> >When the window scale is larger, this middle box bug makes it such
> >that not even one packet can fit into the miscalculated window and
> >things wedge.  The box thinks that your window is "94" instead of
> >"94 << WINDOW_SCALE".
> ..
> 
> Unilaterally following the standard is all well and good
> for those who know how to get around it when a site becomes
> inaccessible, but not for Joe User.

We had very similar issues with ECN. But unlike ECN, window scaling is
not something we can just shrug our shoulders and say "oh well" about.
We will have to deal with it eventually. It might as well be sooner.

-- 
Mathematics is the supreme nostalgia of our time.